"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const qwik = require("@builder.io/qwik");
const jsxRuntime = require("@builder.io/qwik/jsx-runtime");
const build = require("@builder.io/qwik/build");
function qwikifyQrl(reactCmpQrl, opts) {
  return /* @__PURE__ */ qwik.componentQrl(qwik.inlinedQrl((props) => {
    const [opts2, reactCmpQrl2] = qwik.useLexicalScope();
    const hostElement = qwik.useHostElement();
    const store = qwik.useStore({});
    const clientOnly = !!(props["client:only"] || opts2?.clientOnly);
    let eagerness;
    if (props["client:visible"] || opts2?.eagerness === "visible")
      eagerness = "visible";
    else if (props["client:load"] || clientOnly || opts2?.eagerness === "load")
      eagerness = "load";
    qwik.useWatchQrl(qwik.inlinedQrl(async (track) => {
      const [hostElement2, props2, reactCmpQrl3, store2] = qwik.useLexicalScope();
      track(props2);
      if (build.isBrowser) {
        if (store2.data)
          store2.data.root.render(store2.data.client.Main(store2.data.cmp, filterProps(props2)));
        else {
          const [Cmp, client] = await Promise.all([
            reactCmpQrl3.resolve(),
            Promise.resolve().then(() => require("./client.68c2f815.cjs"))
          ]);
          let root;
          if (hostElement2.childElementCount > 0)
            root = client.hydrateRoot(hostElement2, client.Main(Cmp, filterProps(props2), store2.event));
          else {
            root = client.createRoot(hostElement2);
            root.render(client.Main(Cmp, filterProps(props2)));
          }
          store2.data = qwik.noSerialize({
            client,
            cmp: Cmp,
            root
          });
        }
      }
    }, "qwikifyQrl_component_useWatch_x04JC5xeP1U", [
      hostElement,
      props,
      reactCmpQrl2,
      store
    ]), {
      eagerness
    });
    if (build.isServer && !clientOnly) {
      const jsx = Promise.all([
        reactCmpQrl2.resolve(),
        Promise.resolve().then(() => require("./server.b7ed3313.cjs"))
      ]).then(([Cmp, server]) => {
        const html = server.render(Cmp, filterProps(props));
        return /* @__PURE__ */ jsxRuntime.jsx(qwik.Host, {
          dangerouslySetInnerHTML: html
        });
      });
      return /* @__PURE__ */ jsxRuntime.jsx(jsxRuntime.Fragment, {
        children: jsx
      });
    }
    return /* @__PURE__ */ jsxRuntime.jsx(qwik.Host, {
      children: /* @__PURE__ */ jsxRuntime.jsx(qwik.SkipRerender, {})
    });
  }, "qwikifyQrl_component_zH94hIe0Ick", [
    opts,
    reactCmpQrl
  ]), {
    tagName: opts?.tagName ?? "qwik-wrap"
  });
}
const filterProps = (props) => {
  const obj = {};
  Object.keys(props).forEach((key) => {
    if (!key.startsWith("client:"))
      obj[key] = props[key];
  });
  return obj;
};
const qwikify$ = /* @__PURE__ */ qwik.implicit$FirstArg(qwikifyQrl);
async function renderToString(rootNode, opts) {
  const mod = await Promise.resolve().then(() => require("./server.b7ed3313.cjs"));
  const result = await mod.renderToString(rootNode, opts);
  const styles = mod.getGlobalStyleTag(result.html);
  const finalHtml = result.html.replace("</head>", styles + "</head>");
  return {
    ...result,
    html: finalHtml
  };
}
function qwikReact() {
  const OPTIMIZE_DEPS = [
    "react",
    "react-dom/client",
    "hoist-non-react-statics",
    "@emotion/react"
  ];
  const DEDUPE = [
    "react",
    "react-dom",
    "@emotion/react"
  ];
  return {
    name: "vite-plugin-qwik-react",
    config() {
      return {
        resolve: {
          dedupe: DEDUPE
        },
        optimizeDeps: {
          include: OPTIMIZE_DEPS
        }
      };
    }
  };
}
exports.qwikReact = qwikReact;
exports.qwikify$ = qwikify$;
exports.qwikifyQrl = qwikifyQrl;
exports.renderToString = renderToString;
