"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const jsxRuntime = require("@emotion/react/jsx-runtime");
const react$1 = require("@emotion/react");
const server$1 = require("react-dom/server");
const createEmotionServer = require("@emotion/server/create-instance");
const createCache = require("@emotion/cache");
const react = require("react");
const server = require("@builder.io/qwik/server");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const createEmotionServer__default = /* @__PURE__ */ _interopDefaultLegacy(createEmotionServer);
const createCache__default = /* @__PURE__ */ _interopDefaultLegacy(createCache);
const key = "css";
const cache = createCache__default.default({
  key
});
const { extractCriticalToChunks, constructStyleTagsFromChunks } = createEmotionServer__default.default(cache);
function getGlobalStyleTag(html) {
  const chunks = extractCriticalToChunks(html);
  const style = constructStyleTagsFromChunks(chunks);
  return style;
}
function render(App, props) {
  const html = server$1.renderToString(/* @__PURE__ */ jsxRuntime.jsx(react$1.CacheProvider, {
    value: cache,
    children: /* @__PURE__ */ jsxRuntime.jsx(App, {
      ...props
    })
  }));
  return html;
}
Object.defineProperty(exports, "createElement", {
  enumerable: true,
  get: () => react.createElement
});
Object.defineProperty(exports, "renderToString", {
  enumerable: true,
  get: () => server.renderToString
});
exports.constructStyleTagsFromChunks = constructStyleTagsFromChunks;
exports.extractCriticalToChunks = extractCriticalToChunks;
exports.getGlobalStyleTag = getGlobalStyleTag;
exports.render = render;
