import { jsx } from "@emotion/react/jsx-runtime";
import { CacheProvider } from "@emotion/react";
import { renderToString } from "react-dom/server";
import createEmotionServer from "@emotion/server/create-instance";
import createCache from "@emotion/cache";
import { createElement } from "react";
import { renderToString as renderToString2 } from "@builder.io/qwik/server";
const key = "css";
const cache = createCache({
  key
});
const { extractCriticalToChunks, constructStyleTagsFromChunks } = createEmotionServer(cache);
function getGlobalStyleTag(html) {
  const chunks = extractCriticalToChunks(html);
  const style = constructStyleTagsFromChunks(chunks);
  return style;
}
function render(App, props) {
  const html = renderToString(/* @__PURE__ */ jsx(CacheProvider, {
    value: cache,
    children: /* @__PURE__ */ jsx(App, {
      ...props
    })
  }));
  return html;
}
export {
  constructStyleTagsFromChunks,
  createElement,
  extractCriticalToChunks,
  getGlobalStyleTag,
  render,
  renderToString2 as renderToString
};
