import { NoSerialize, QRL } from '@builder.io/qwik';
import type { Root } from 'react-dom/client';
import type { FunctionComponent } from 'react';
export interface Internal<PROPS> {
    root: Root;
    client: typeof import('./client');
    cmp: FunctionComponent<PROPS>;
}
export interface QwikifyCmp<PROPS extends {}> {
    data?: NoSerialize<Internal<PROPS>>;
    event?: NoSerialize<any>;
}
export declare type QwikifyProps<PROPS extends {}> = PROPS & {
    'client:load'?: boolean;
    'client:visible'?: boolean;
    'client:only'?: boolean;
};
export interface QwikifyOptions {
    tagName?: string;
    eagerness?: 'load' | 'visible';
    clientOnly?: boolean;
}
export declare function qwikifyQrl<PROPS extends {}>(reactCmpQrl: QRL<FunctionComponent<PROPS>>, opts?: QwikifyOptions): import("@builder.io/qwik").Component<QwikifyProps<PROPS>>;
export declare const filterProps: (props: Record<string, any>) => Record<string, any>;
export declare const qwikify$: <PROPS extends {}>(first: FunctionComponent<PROPS>, opts?: QwikifyOptions | undefined) => import("@builder.io/qwik").Component<QwikifyProps<PROPS>>;
